--- token.c.1.74	2004-01-14 15:01:43.000000000 -0500
+++ token.c	2004-01-23 12:16:50.000000000 -0500
@@ -227,6 +227,8 @@
     }
 
     if (!msg_count_file) {
+	bool convert_all = true;
+
 	/* Remove trailing blanks */
 	/* From "From ", for example */
 	while (yylval->leng > 1 && yylval->text[yylval->leng-1] == ' ') {
@@ -244,8 +246,16 @@
 	 * depending on options set, replace nonascii characters by '?'s
 	 * and/or replace upper case by lower case
 	 */
-	for (cp = yylval->text; cp < yylval->text+yylval->leng; cp += 1)
-	    *cp = casefold_table[*cp];
+	for (cp = yylval->text; cp < yylval->text+yylval->leng; cp += 1) {
+	    char ch = casefold_table[*cp];
+	    if (convert_all && 
+		ch == '?' && ch != *cp ) {
+		for (cp = yylval->text; cp < yylval->text+yylval->leng; cp += 1)
+		    *cp = '?';
+		break;
+	    }
+	    *cp = ch;
+	}
     }
 
     return(cls);
